import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Whale here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Whale extends Actor
{
    Background bg= (Background) getWorld();
    Counter counter = new Counter();
    int cloudCount = 0; 
    int random = Greenfoot.getRandomNumber(100);
    int petuniaCount = 0;
    int otherRandom = Greenfoot.getRandomNumber(500);
    int score = 0;
    int time = 0;
    String image1 = "skull.png";
    String image2 = "Whale.png";
    boolean checkForEnd = false;
    Intro intro = new Intro();
    
    public Whale()
    {
        Greenfoot.setSpeed(51);
    }
    
    /**
     *Do whale things. And oh yeah, don't panic!
     */
    public void act() 
    {
        checkKeys();
        cloudCount++;
        time++;
        petuniaCount++;
        addPetunias();
        addClouds();
        collectPetunias();
        timer();
    }   
    
    /**
     * Check to see if the user wants the whale to move
     */
    public void checkKeys()
    {
       if(checkForEnd == false)
       {
            if(Greenfoot.isKeyDown("left") )
            {
                setLocation(getX() - 3, getY() );
            }
            if(Greenfoot.isKeyDown("right"))
            {
                setLocation(getX() + 3, getY() );
            }
        }
        else
        {}
    }
    
    /**
     * Randomly add useless clouds of uselessness
     */
    public void addClouds()
    {
        if (checkForEnd == false)
        {
            if (cloudCount >= random)
            {
                Background bg= (Background) getWorld();
                bg.addObject(new Cloud(), Greenfoot.getRandomNumber(400) + 50, 800);
                cloudCount = 0;
                random = Greenfoot.getRandomNumber(100);
            }
            else
            {}
        }
        
    }
    
    /**
     * Randomly add useful petunias of usefulness
     */
    public void addPetunias()
    {
        if (checkForEnd == false)
        {
            if (petuniaCount >= otherRandom)
            {
                Background bg= (Background) getWorld();
                bg.addObject(new Petunia(), Greenfoot.getRandomNumber(400) + 50, 800);
                petuniaCount = 0;
                otherRandom = Greenfoot.getRandomNumber(100);
            }
            else
            {}
        }
    }
    
    /**
     * See if you can see an object
     */
    
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    
    /**
     * Get rid o' dat object
     */
    public void collect(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
    
    /**
     * Destroy ALL petunias!! (That come into contact with the whale)
     */
    public void collectPetunias()
    {
        if(canSee(Petunia.class))
        {
            Counter counter = new Counter();
            collect(Petunia.class);
            counter.add(1);
        }
    }
    
    /**
     * Count up for two minutes (8,400 act methods at speed 51)
     */
    public void timer()
    {
        if (time >= 8400)
        {           
            if (canSee(Freind.class))
            {
                setImage(image1);
            }
                
            else
            {
                setLocation(getX(), getY() + 5 );
            }
          
            checkForEnd = true;
        }
        if (time == 8400)
        {
            Background bg= (Background) getWorld();
            bg.addObject(new Freind(), 250, 800);
            bg.addObject(new Ending(), 250, 400);
        }
        
        if (time == 1)
        {
            collect(Intro.class);
        }
    }
}
